import javax.naming.*;
import java.util.Properties;
import java.util.Enumeration;
import java.util.Hashtable;
import java.io.*;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;

import org.gxos.*;
import org.gxos.config.GXOSConfiguration;
import org.gxos.schema.*;
import org.gxos.schema.types.*;
import org.gxos.debug.Log;
import org.gxos.gndi.context.*;
import org.gxos.xml.*;
import org.gxos.util.*;

import garnet.gateway.schema.*;

public class GenXMLSchemaToDB {
    
    public static void main(String[] args) {
 
	try {

	    String configFile = "/a/birch.csit.fsu.edu/shared/home/cyoun/GXOS/gxoslibs/gxos.conf";
	    Properties env = Defaults.getConfiguration(configFile);

	    ContextManager.initialize(env);
	    XMLObject gateway = ContextManager.getDatabase("Gateway");

	    ApplicationDescription ad = (ApplicationDescription)Defaults.initEntity( new ApplicationDescription(), "ApplicationDescriptor", NodeTypeType.COLLECTION, NodeRootingType.LEAF);

	    ad.setComment("This is a revision of ApplDesc.xml using the gxos.");
	    gateway.addObject(ad);

	    Application a = (Application)Defaults.initEntity(new Application(), "Ising_demo", NodeTypeType.COLLECTION, NodeRootingType.INTERNALNODE);
        
	    a.setComment("This is Ising application.");
	    a.setParameters(new Parameters());
	    CustomParameters.setValue(a.getParameters(), "NumberOfInParams", "1");
	    CustomParameters.setValue(a.getParameters(), "NumberOfInFiles", "1");
	    CustomParameters.setValue(a.getParameters(), "NumberOfOutParams", "1");
	    CustomParameters.setValue(a.getParameters(), "NumberOfOutFiles", "1");
	    CustomParameters.setValue(a.getParameters(), "IOStyle", "StandardIO");
        
	    Machine m = new Machine();
	    m.setName("dirac");
	    m.setParameters(new Parameters());
	    CustomParameters.setValue(m.getParameters(), "HostName", "dirac.csit.fsu.edu");
	    CustomParameters.setValue(m.getParameters(), "QueueType", "DQS");
	    CustomParameters.setValue(m.getParameters(), "ExecPath", "/home/scri99/users/gateway/Ising/ising_aix");
	    CustomParameters.setValue(m.getParameters(), "WorkDir", "/tmp/Ising");
	    CustomParameters.setValue(m.getParameters(), "QsubPath", "/usr/local/bin/tcsh");
	    CustomParameters.setValue(m.getParameters(), "CLASSPATH", "/tmp");

	    a.addMachine(m);
        
	    m = new Machine();
	    m.setName("birch");
	    m.setParameters(new Parameters());
	    CustomParameters.setValue(m.getParameters(), "HostName", "birch.csit.fsu.edu");
	    CustomParameters.setValue(m.getParameters(), "QueueType", "DQS");
	    CustomParameters.setValue(m.getParameters(), "ExecPath", "/home/scri99/users/gateway/Ising/ising_sun");
	    CustomParameters.setValue(m.getParameters(), "WorkDir", "/tmp/Ising");
	    CustomParameters.setValue(m.getParameters(), "QsubPath", "/home/scri97/users/cyoun/birch/bin/tcsh");
	    CustomParameters.setValue(m.getParameters(), "CLASSPATH", "/tmp");

	    a.addMachine(m);

	    m = new Machine();
	    m.setName("zeus");
	    m.setParameters(new Parameters());
	    CustomParameters.setValue(m.getParameters(), "HostName", "zeus.csit.fsu.edu");
	    CustomParameters.setValue(m.getParameters(), "QueueType", "DQS");
	    CustomParameters.setValue(m.getParameters(), "ExecPath", "/home/guest/gateway/Ising/ising_sgi");
	    CustomParameters.setValue(m.getParameters(), "WorkDir", "/tmp/Ising");
	    CustomParameters.setValue(m.getParameters(), "QsubPath", "/usr/local/bin/tcsh");
	    CustomParameters.setValue(m.getParameters(), "CLASSPATH", "/tmp");

	    a.addMachine(m);
        
	    VisualizationToolkit vtk = new VisualizationToolkit();
	    vtk.setName("gnuplot");
	    vtk.setParameters(new Parameters());
	    CustomParameters.setValue(vtk.getParameters(), "VizName", "gnuplot");
	    CustomParameters.setValue(vtk.getParameters(), "VizHostName", "dirac.csit.fsu.edu");
	    CustomParameters.setValue(vtk.getParameters(), "VizPath", "/home/scri99/users/gateway/gnuplot-3.7.1/bin/gnuplot");

	    a.addVisualizationToolkit(vtk);

	    vtk = new VisualizationToolkit();
	    vtk.setName("matlab");
	    vtk.setParameters(new Parameters());
	    CustomParameters.setValue(vtk.getParameters(), "VizName", "matlab");
	    CustomParameters.setValue(vtk.getParameters(), "VizHostName", "zeus.csit.fsu.edu");
	    CustomParameters.setValue(vtk.getParameters(), "VizPath", "/usr/local/bin/matlab");

	    a.addVisualizationToolkit(vtk);


	    XMLObject appdesc = gateway.getChild("ApplicationDescriptor");
	    appdesc.addObject( a );
	    //String appls[] = appdesc.getChildren();


	    a = (Application)Defaults.initEntity(new Application(), "Ising_demo_quick", NodeTypeType.COLLECTION, NodeRootingType.INTERNALNODE);
        
	    a.setComment("This is Ising Quick application.");
	    a.setParameters(new Parameters());
	    CustomParameters.setValue(a.getParameters(), "NumberOfInParams", "1");
	    CustomParameters.setValue(a.getParameters(), "NumberOfInFiles", "1");
	    CustomParameters.setValue(a.getParameters(), "NumberOfOutParams", "1");
	    CustomParameters.setValue(a.getParameters(), "NumberOfOutFiles", "1");
	    CustomParameters.setValue(a.getParameters(), "IOStyle", "StandardIO");
        
	    m = new Machine();
	    m.setName("dirac");
	    m.setParameters(new Parameters());
	    CustomParameters.setValue(m.getParameters(), "HostName", "dirac.csit.fsu.edu");
	    CustomParameters.setValue(m.getParameters(), "QueueType", "DQS");
	    CustomParameters.setValue(m.getParameters(), "ExecPath", "/home/scri99/users/gateway/Ising/ising_aix_quick");
	    CustomParameters.setValue(m.getParameters(), "WorkDir", "/tmp/Ising");
	    CustomParameters.setValue(m.getParameters(), "QsubPath", "/usr/local/bin/tcsh");
	    CustomParameters.setValue(m.getParameters(), "CLASSPATH", "/tmp");

	    a.addMachine(m);
        
	    m = new Machine();
	    m.setName("birch");
	    m.setParameters(new Parameters());
	    CustomParameters.setValue(m.getParameters(), "HostName", "birch.csit.fsu.edu");
	    CustomParameters.setValue(m.getParameters(), "QueueType", "DQS");
	    CustomParameters.setValue(m.getParameters(), "ExecPath", "/home/scri99/users/gateway/Ising/ising_sun_quick");
	    CustomParameters.setValue(m.getParameters(), "WorkDir", "/tmp/Ising");
	    CustomParameters.setValue(m.getParameters(), "QsubPath", "/home/scri97/users/cyoun/birch/bin/tcsh");
	    CustomParameters.setValue(m.getParameters(), "CLASSPATH", "/tmp");

	    a.addMachine(m);

	    m = new Machine();
	    m.setName("zeus");
	    m.setParameters(new Parameters());
	    CustomParameters.setValue(m.getParameters(), "HostName", "zeus.csit.fsu.edu");
	    CustomParameters.setValue(m.getParameters(), "QueueType", "DQS");
	    CustomParameters.setValue(m.getParameters(), "ExecPath", "/home/guest/gateway/Ising/ising_sgi_quick");
	    CustomParameters.setValue(m.getParameters(), "WorkDir", "/tmp/Ising");
	    CustomParameters.setValue(m.getParameters(), "QsubPath", "/usr/local/bin/tcsh");
	    CustomParameters.setValue(m.getParameters(), "CLASSPATH", "/tmp");

	    a.addMachine(m);
        
	    vtk = new VisualizationToolkit();
	    vtk.setName("gnuplot");
	    vtk.setParameters(new Parameters());
	    CustomParameters.setValue(vtk.getParameters(), "VizName", "gnuplot");
	    CustomParameters.setValue(vtk.getParameters(), "VizHostName", "dirac.csit.fsu.edu");
	    CustomParameters.setValue(vtk.getParameters(), "VizPath", "/home/scri99/users/gateway/gnuplot-3.7.1/bin/gnuplot");

	    a.addVisualizationToolkit(vtk);

	    vtk = new VisualizationToolkit();
	    vtk.setName("matlab");
	    vtk.setParameters(new Parameters());
	    CustomParameters.setValue(vtk.getParameters(), "VizName", "matlab");
	    CustomParameters.setValue(vtk.getParameters(), "VizHostName", "zeus.csit.fsu.edu");
	    CustomParameters.setValue(vtk.getParameters(), "VizPath", "/usr/local/bin/matlab");

	    a.addVisualizationToolkit(vtk);


	    appdesc = gateway.getChild("ApplicationDescriptor");
	    appdesc.addObject( a );
	    //String appls[] = appdesc.getChildren();

        
	} catch(Exception e) {
	    e.printStackTrace();
	}
    }
}












